Index: test/jdbc2/DatabaseMetaDataTest.java
===================================================================
RCS file: /usr/local/cvsroot/pgjdbc/pgjdbc/org/postgresql/test/jdbc2/DatabaseMetaDataTest.java,v
retrieving revision 1.22
diff -c -b -B -r1.22 DatabaseMetaDataTest.java
*** test/jdbc2/DatabaseMetaDataTest.java	12 Dec 2003 18:30:27 -0000	1.22
--- test/jdbc2/DatabaseMetaDataTest.java	13 May 2004 14:23:31 -0000
***************
*** 524,527 ****
--- 524,620 ----
  		}
  	}
  
+     public void testGetUDTQualified()
+     {
+         Statement stmt =  null;
+         try
+         {
+             stmt = con.createStatement();
+             stmt.execute("create schema jdbc");
+             stmt.execute("create type jdbc.testint8 as (i int8)");
+             DatabaseMetaData dbmd = con.getMetaData();
+             ResultSet rs = dbmd.getUDTs(null, null ,"jdbc.testint8" , null);
+             assertTrue(rs.next());
+             String cat, schema, typeName, remarks, className;
+             int dataType;
+             int baseType;
+ 
+             cat = rs.getString("type_cat");
+             schema = rs.getString("type_schem");
+             typeName = rs.getString( "type_name");
+             className = rs.getString("class_name");
+             dataType = rs.getInt("data_type");
+             remarks = rs.getString( "remarks" );
+             baseType = rs.getInt("base_type");
+             this.assertEquals("type name ", "testint8", typeName);
+             this.assertEquals("schema name ", "jdbc",schema);
+ 
+             // now test to see if the fully qualified stuff works as planned
+             rs = dbmd.getUDTs("catalog", "public" ,"catalog.jdbc.testint8" , null);
+             assertTrue(rs.next());
+             cat = rs.getString("type_cat");
+             schema = rs.getString("type_schem");
+             typeName = rs.getString( "type_name");
+             className = rs.getString("class_name");
+             dataType = rs.getInt("data_type");
+             remarks = rs.getString( "remarks" );
+             baseType = rs.getInt("base_type");
+             this.assertEquals("type name ", "testint8", typeName);
+             this.assertEquals("schema name ", "jdbc",schema);
+         }
+         catch( SQLException ex )
+         {
+             fail( ex.getMessage() );
+         }
+         finally
+         {
+             try
+             {
+                 if (stmt != null )
+                     stmt.close();
+                 stmt = con.createStatement();
+                 stmt.execute("drop type jdbc.testint8");
+                 stmt.execute("drop schema jdbc");
+             }
+             catch( Exception ex ){}
+         }
+ 
+     }
+     public void testGetUDT()
+     {
+         try
+         {
+             Statement stmt = con.createStatement();
+             stmt.execute("create type testint8 as (i int8)");
+             DatabaseMetaData dbmd = con.getMetaData();
+             ResultSet rs = dbmd.getUDTs(null, null ,"testint8" , null);
+             assertTrue(rs.next());
+             String cat, schema, typeName, remarks, className;
+             int dataType;
+             int baseType;
+ 
+             cat = rs.getString("type_cat");
+             schema = rs.getString("type_schem");
+             typeName = rs.getString( "type_name");
+             className = rs.getString("class_name");
+             dataType = rs.getInt("data_type");
+             remarks = rs.getString( "remarks" );
+             baseType = rs.getInt("base_type");
+             this.assertEquals("type name ", "testint8", typeName);
+ 
+         }
+         catch( SQLException ex )
+         {
+             fail( ex.getMessage() );
+         }
+         finally
+         {
+             try
+             {
+                 Statement stmt = con.createStatement();
+                 stmt.execute("drop type testint8");
+             }
+             catch( Exception ex ){}
+         }
+     }
  }
Index: jdbc2/AbstractJdbc2DatabaseMetaData.java
===================================================================
RCS file: /usr/local/cvsroot/pgjdbc/pgjdbc/org/postgresql/jdbc2/AbstractJdbc2DatabaseMetaData.java,v
retrieving revision 1.7
diff -c -b -B -r1.7 AbstractJdbc2DatabaseMetaData.java
*** jdbc2/AbstractJdbc2DatabaseMetaData.java	24 Apr 2004 20:58:16 -0000	1.7
--- jdbc2/AbstractJdbc2DatabaseMetaData.java	13 May 2004 14:23:51 -0000
***************
*** 107,114 ****
  		return true;
  	}
  
! 	/*
! 	 * Return user defined types in a schema
  	 */
  	public java.sql.ResultSet getUDTs(String catalog,
  									  String schemaPattern,
--- 107,120 ----
  		return true;
  	}
  
!     /**
!      *
!      * @param catalog String
!      * @param schemaPattern String
!      * @param typeNamePattern String
!      * @param types int[]
!      * @throws SQLException
!      * @return ResultSet
       */
      public java.sql.ResultSet getUDTs(String catalog,
  									  String schemaPattern,
***************
*** 116,122 ****
  									  int[] types
  									 ) throws SQLException
  	{
! 		throw org.postgresql.Driver.notImplemented();
  	}
  
  
--- 122,167 ----
  									  int[] types
  									 ) throws SQLException
  	{
! 		String sql = "select "
!                    + "null as type_cat, n.nspname as type_schem, t.typname as type_name, "
!                    + "null as class_name, null as data_type, null as remarks, null as base_type "
!                    + "from pg_catalog.pg_type t, pg_catalog.pg_namespace n where t.typnamespace = n.oid and t.typname not like 'pg_toast%'";
! 
! 		String toAdd = "";
!         // spec says that if typeNamePattern is not null then the schema and catalog are ignored
! 
!         if (typeNamePattern != null)
!         {
!             // search for qualifier
!             int firstQualifier = typeNamePattern.indexOf('.') ;
!             int secondQualifier = typeNamePattern.lastIndexOf('.');
! 
!             if ( firstQualifier != -1 ) // if one of them is -1 they both will be
!             {
!                 if ( firstQualifier != secondQualifier )
!                 {
!                     // we have a catalog.schema.typename, ignore catalog
!                     schemaPattern =  typeNamePattern.substring(firstQualifier+1, secondQualifier);
!                 }
!                 else
!                 {
!                     // we just have a schema.typename
!                     schemaPattern = typeNamePattern.substring(0,firstQualifier);
!                 }
!                 // strip out just the typeName
!                 typeNamePattern = typeNamePattern.substring(secondQualifier+1);
!             }
!             toAdd += " and t.typname like '" + typeNamePattern + "'";
!         }
! 
!         // schemaPattern may have been modified above
!         if ( schemaPattern != null)
!         {
! 			toAdd += " and n.nspname like '" + schemaPattern +"'";
!         }
! 		sql += toAdd;
! 		java.sql.ResultSet rs = connection.createStatement().executeQuery(sql);
! 		return rs;
  	}
  
  
